/*
  7 segments Libraries 
 
 Demonstrates the use a 7 segments display.
 
 This sketch prints "Hello World!".
 
  The circuit:
 * Segment a pin to Resistor 680 to digital pin 0
 * Segment b pin to Resistor 680 to digital pin 1
 * Segment c pin to Resistor 680 to digital pin 2
 * Segment d pin to Resistor 680 to digital pin 3
 * Segment e pin to Resistor 680 to digital pin 4
 * Segment f pin to Resistor 680 to digital pin 5
 * Segment g pin to Resistor 680 to digital pin 6
 * Segment dp pin to Resistor 680 to digital pin 7
 * Common Anode 1 pin to digital pin 8
 * Common Anode 2 pin to digital pin 9
 * Common Anode 3 pin to digital pin 10
 * Common Anode 4 pin to digital pin 11
 
 Library originally write 1 Sep 2012 by Laurent LE GOFF 
 
 This example code is in the public domain.
 */

#include <SevenSeg.h>
#include <MsTimer2.h>

/* SevenSeg (Anode or Cathode, Direct or Transistor,a,b,c,d,e,f,g,dp,com1,com2,com3,com4)  [com2 -> com8] */
SevenSeg afficheur(Anode,Direct,0,1,2,3,4,5,6,7,8,9,10,11);

void setup()
{ 
  MsTimer2::set(5, interrupt); // 50Hz
  MsTimer2::start();
}

void interrupt()
{
  afficheur.multiplex();
}

void loop()
{
  afficheur.println("Hell");
  delay(1000);
  afficheur.println("ello");
  delay(1000);
  afficheur.println("llo ");
  delay(1000);
  afficheur.println("lo W");
  delay(1000);
  afficheur.println("o Wo");
  delay(1000);
  afficheur.println(" Wor");
  delay(1000);
  afficheur.println("Worl");
  delay(1000);
  afficheur.println("orld.");
  delay(1000);
  afficheur.println("rld. ");
  delay(1000);
  afficheur.println("ld.  ");
  delay(1000);
  afficheur.print("d.   ");
  delay(1000);
  afficheur.clear();
  delay(1000);
}
